# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright (C) 2011 Claudio Novais <ubuntued+walls@gmail.com>
# This program is free software: you can redistribute it and/or modify it 
# under the terms of the GNU General Public License version 3, as published 
# by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranties of 
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
# PURPOSE.  See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along 
# with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE

import gtk
from ubuntued_desktop.libs.uploader import *
from ubuntued_desktop.helpers import get_builder

import gettext
from gettext import gettext as _
gettext.textdomain('ubuntued-desktop')

class CodeDialog(gtk.Dialog):
    __gtype_name__ = "CodeDialog"

    def __new__(cls):
        """Special static method that's automatically called by Python when 
        constructing a new instance of this class.
        
        Returns a fully instantiated CodeDialog object.
        """
        
        builder = get_builder('CodeDialog')
        new_object = builder.get_object('code_dialog')
        new_object.finish_initializing(builder)
        return new_object

    def finish_initializing(self, builder):
        """Called when we're finished initializing.

        finish_initalizing should be called after parsing the ui definition
        and creating a CodeDialog object with it in order to
        finish initializing the start of the new CodeDialog
        instance.
        """
        # Get a reference to the builder and set up the signals.
        self.builder = builder
        self.builder.connect_signals(self)
        
        self.textview = self.builder.get_object('textview1')

    def ok(self, widget, data=None):
        """The user has elected to save the changes.

        Called before the dialog returns gtk.RESONSE_OK from run().
        """
        self.destroy()
        

    def on_buttonCopiar_clicked(self, widget, data=None):
        textbuffer = self.textview.get_buffer()
        self.setClipBoard( textbuffer.get_text(textbuffer.get_start_iter(),textbuffer.get_end_iter()))
        self.broadcast("Codigo enviado para o ClipBoard!")
    
    def setCode(self, code):
        self.textview.get_buffer().set_text(code)
    
    def broadcast(self, l):
        try:
            n = pynotify.Notification(l,"","dialog-information")
            n.set_urgency(pynotify.URGENCY_LOW)
            n.show()
        except:
            for line in l:
                print line

    def setClipBoard(self,texto):
        c = gtk.Clipboard()
        c.set_text(texto)
        c.store()
        self.broadcast("Codigo enviado para o ClipBoard!")

if __name__ == "__main__":
    dialog = CodeDialog()
    dialog.show()
    gtk.main()
